# Update .po with messages translates in other .po.
# Licenced by GPL 3 or (at your option) any later version.
# Copyright (C) 2009 Marcos Alvarez

# poupdate is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public Licence as published
# by the Free Software Foundation; either version 3 of the Licence,
# or (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys

# VARIABLES
v_file_from   = ""
v_file_to     = ""
c_separator   = "***"





# RUTINES
# Change special characters & c_separator 
def change_characters(p_string):
    if p_string == "":
        return
    
    p_string = p_string.replace(c_separator,"\n")

	
	
# Load file to list
def file_to_list(p_file, p_list):
    try:
        l_file = open(p_file, "r") 
    except IOError:
        print "Error open file: " + p_file
        print "Check parameters"
        print "End Program"
        return 1

    l_line_concatenate = ""
    
    while True:
        l_line = l_file.readline()
        if not l_line: break


        if l_line != "\n":
            if l_line_concatenate == "":
                l_line_concatenate = l_line
            else:
                l_line_concatenate = "".join([l_line_concatenate,l_line])

        else:
            l_line_concatenate = l_line_concatenate.replace("\n",c_separator)
            p_list.append(l_line_concatenate)
            l_line_concatenate = ""
                
    l_file.close() 

    if l_line_concatenate != "":
        p_list.append(l_line_concatenate)
            
    return 0




# START PROGRAM
# Get parameters
if len(sys.argv) != 4:
    print "Syntax: python poupdate.py template.pot translated_file.po new_translate_file.po"
    sys.exit()
v_file_from   = sys.argv[1]
v_file_to     = sys.argv[2]
c_file_finish = sys.argv[3]
if ( v_file_from == "" or v_file_to == "" ) or ( v_file_from == v_file_to ):
    print "Error wit parameters"
    print "Syntax: python poupdate.py template.pot translated_file.po new_translate_file.po"
    sys.exit()

print "Translating..."





# Cargar ficheros
l_file_from = []
l_file_to   = []
if file_to_list(v_file_from,l_file_from) != 0:
    sys.exit()
if file_to_list(v_file_to,l_file_to) != 0:
    sys.exit()
l_file_finish = open(c_file_finish, "w")
l_ind = 1

for l_line in l_file_from:

    # Record header
    if l_ind == 1:
        l_ind = l_ind + 1
        l_line = l_line.replace(c_separator,"\n")
        l_line = "".join([l_line,"\n"])
        l_file_finish.write(l_line)
    else:

        l_split_msgid = l_line.split("msgid ")
        # If no msgid, next line
        if len(l_split_msgid) == 1:
            l_line = l_line.replace(c_separator,"\n")
            l_line = "".join([l_line,"\n"])
            l_file_finish.write(l_line)
        else:
                
            # Search plural
            if l_split_msgid[1].find("msgid_plural ") != -1:
                l_split_plural = l_split_msgid[1].split("msgstr[0]")
                # Error
                if len(l_split_plural) == 1:
                    l_line = l_line.replace(c_separator,"\n")
                    l_line = "".join([l_line,"\n"])
                    l_file_finish.write(l_line)
                # Good
                else:
                    l_found = " "
                    for l_aux in l_file_to:
                        # Found
                        if l_aux.find(l_split_plural[0]) != -1:
                            l_found = "X"
                            l_aux_split = l_aux.split("msgstr[0]")
                            l_line_join = "".join([l_split_msgid[0],"msgid ",l_split_plural[0],"msgstr[0]",l_aux_split[1]])
                            l_line_join = l_line_join.replace(c_separator,"\n")
                            l_line_join = "".join([l_line_join ,"\n"])
                            l_file_finish.write(l_line_join )
                            break
                    # Not found
                    if l_found != "X":
                        l_line = l_line.replace(c_separator,"\n")
                        l_line = "".join([l_line,"\n"])
                        l_file_finish.write(l_line)
                                            
            # Search msgstr	
            else:

                l_split_msgstr = l_split_msgid[1].split("msgstr ")
                
                #Error
                if len(l_split_msgstr) == 1:
                    l_line = l_line.replace(c_separator,"\n")
                    l_line = "".join([l_line,"\n"])
                    l_file_finish.write(l_line)
                else:
                    l_found = " "
                    for l_aux in l_file_to:
                        # Found
                        if l_aux.find(l_split_msgstr[0]) != -1:
                            l_found = "X"
                            l_aux_split = l_aux.split("msgstr ")
                            l_line_join = "".join([l_split_msgid[0],"msgid ",l_split_msgstr[0],"msgstr ",l_aux_split[1]])
                            l_line_join = l_line_join.replace(c_separator,"\n")
                            l_line_join = "".join([l_line_join,"\n"])
                            l_file_finish.write(l_line_join)
                            break
                    # Not found
                    if l_found != "X":
                        l_line = l_line.replace(c_separator,"\n")
                        l_line = "".join([l_line,"\n"])
                        l_file_finish.write(l_line)

l_file_finish.close()
print "End program. Created file: " + c_file_finish
